<?php
/**
* alibaba(阿里巴巴平台)直销订单处理
*
* @category apibusiness
* @package apibusiness/response/order/alibaba
* @author wangkezheng<wangkezheng@shopex.cn>
* @version $Id: b2cv1.php 2014-12-25 
*/
class apibusiness_response_order_alibaba_b2cv1 extends apibusiness_response_order_alibaba_abstract
{
    #对平台接收的数据纠正
    public function reTransSdf(){
        parent::reTransSdf();
        $this->reTransSdf_pmt_order();
    }
    #重新纠正阿里巴巴的订单优惠(订单总优惠=商品金额+运费-实收金额)
    public function  reTransSdf_pmt_order(){
        $total_amount = (float) $this->_ordersdf['cost_item']
        + (float) $this->_ordersdf['shipping']['cost_shipping']
        + (float) $this->_ordersdf['shipping']['cost_protect']
        + (float) $this->_ordersdf['discount']
        + (float) $this->_ordersdf['cost_tax']
        + (float) $this->_ordersdf['payinfo']['cost_payment']
        - (float) $this->_ordersdf['pmt_goods']
        - (float) $this->_ordersdf['pmt_order'];
        if(0 != bccomp($total_amount, $this->_ordersdf['total_amount'],3)){
            $pmt_order =   $total_amount - $this->_ordersdf['total_amount'];#差额全放订单总优惠上
            if($pmt_order > 0){
                $this->_ordersdf['pmt_order'] = $pmt_order;
            }
        }
        return true;
    }

    /**
     * 获取更新信息插件
     *
     * @return void
     * @author 
     **/
    public function get_update_plugins()
    {
        $plugins = parent::get_update_plugins();

        $plugins[] = 'member';
        $plugins[] = 'promotion';
        $plugins[] = 'payment';
        $plugins[] = 'refundapply';
        return $plugins;
    }


    /**
     * 允许更新
     *
     * @return void
     * @author 
     **/
    protected function canUpdate()
    {
        if( ($this->_tgOrder['ship_status'] == 0) && ($this->_tgOrder['shipping']['is_cod'] == 'true') && ($this->_ordersdf['status'] != 'active') && ($this->_ordersdf['shipping']['is_cod'] == 'true') ){
            // 取消订单
            $memo = '前端店铺:'.$this->_shop['name'].'订单作废';

            $orderModel = app::get(self::_APP_NAME)->model('orders');
            $orderModel->cancel($this->_tgOrder['order_id'],$memo,false,'async');
            
            $this->_apiLog['info'][] = '返回值：订单取消成功！';
            $this->shutdown('add');

        }elseif( ($this->_ordersdf['shipping']['is_cod'] == 'true') && ($this->_ordersdf['status'] != 'active') ){
            $this->_apiLog['info']['msg'] = '取消的订单不接收';
            return false;
        } 

        return parent::canUpdate();
    }
}